<template >
    <div class="pagination" v-if="totalPage > 1">
        <a @click="loadPage(1)" :class="['btn','btn-nav', css.linkFirstClass, isOnFirstPage ? css.disabledClass : '']" >
            <span >&laquo;</span>
        </a>
        <a @click="loadPage(productsData.current_page-1)" :class="['btn','btn-nav', css.linkPrevClass, isOnFirstPage ? css.disabledClass : '']" >
            <span >&nbsp;&lsaquo;</span>
        </a>
        <template v-if="notEnoughPages">
            <template v-for="n in totalPage">
                <a @click="loadPage(n)" :class="['btn', css.pageClass, isCurrentPage(n) ? css.activeClass : css.inActiveClass]" v-html="n">
                </a>
            </template>
        </template>
        <template v-else>
            <template v-for="n in windowSize">
                <a @click="loadPage(windowStart+n-1)" :class="['btn', css.pageClass, isCurrentPage(windowStart+n-1) ? css.activeClass : css.inActiveClass]"
                   v-html="windowStart+n-1">
                </a>
            </template>
        </template>

        <a @click="loadPage(productsData.current_page+1)" :class="['btn','btn-nav', css.linkNextClass, isOnLastPage ? css.disabledClass : '']">
            <span >&rsaquo;&nbsp;</span>
        </a>
        <a @click="loadPage(totalPage)" :class="['btn','btn-nav', css.linkLastClass, isOnLastPage ? css.disabledClass : '']">
            <span >&raquo;</span>
        </a>
    </div>
</template>
<script>
    export default {
        name: 'paginator',
        props: {
            productsData:{
                default: null
            },
            css: {
                type: Object,
                default () {
                    return {
                        wrapperClass: 'ui right floated pagination menu',
                        activeClass: 'active large',
                        disabledClass: 'disabled',
                        pageClass: 'page',
                        linkClass: 'icon page',
                        paginationClass: 'ui bottom attached segment grid',
                        paginationInfoClass: 'left floated left aligned six wide column',
                        dropdownClass: 'ui search dropdown',
                    }
                }
            },
            onEachSide: {
                type: Number,
                default () {
                    return 2
                }
            },
        },

        data: function() {
            return {

            }
        },
        methods: {
            loadPage (page) {
                this.$emit('paginator:change-page', page)
            },
            isCurrentPage (page) {
                return page === this.productsData.current_page
            },
            setPaginationData (productsData) {
                this.productsData = productsData
            },
            resetData () {
                this.productsData = null
            }
        },
        computed: {
            totalPage () {
                return this.productsData === null
                    ? 0
                    : this.productsData.last_page
            },
            isOnFirstPage () {
                return this.productsData === null
                    ? false
                    : this.productsData.current_page === 1
            },
            isOnLastPage () {
                return this.productsData === null
                    ? false
                    : this.productsData.current_page === this.productsData.last_page
            },
            notEnoughPages () {
                return this.totalPage < (this.onEachSide * 2) + 4
            },
            windowSize () {
                return this.onEachSide * 2 +1;
            },
            windowStart () {
                if (!this.productsData || this.productsData.current_page <= this.onEachSide) {
                    return 1
                } else if (this.productsData.current_page >= (this.totalPage - this.onEachSide)) {
                    return this.totalPage - this.onEachSide*2
                }
                return this.productsData.current_page - this.onEachSide
            }
        }
    }

</script>
<style>
    .pagination {
        display: block;
    }
    .pagination a.page {
        border: 1px solid lightgray;
        border-radius: 3px;
        padding: 5px 10px;
        margin-right: 2px;
    }
    .pagination a.page.active {
        color: white;
        background-color: #337ab7;
        border: 1px solid lightgray;
        border-radius: 3px;
        padding: 5px 10px;
        margin-right: 2px;
    }
    .pagination a.btn-nav {
        border: 1px solid lightgray;
        border-radius: 3px;
        padding: 5px 7px;
        margin-right: 2px;
    }
    .pagination a.btn-nav.disabled {
        color: lightgray;
        border: 1px solid lightgray;
        border-radius: 3px;
        padding: 5px 7px;
        margin-right: 2px;
        cursor: not-allowed;
    }
</style>